/***************************************************************************
 *   Copyright (C) 2004 by Andr Stein                                     *
 *   stone@steinsoft.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SGLSL_EXTENSION_H
#define SGLSL_EXTENSION_H

#include <GL/gl.h>
#include <GL/glext.h>
#include <string>

using namespace std;

//either SDL or win style
#if (defined(WIN32) || defined(_WIN32) || defined(__WIN32) || defined(__WIN32__))
	#define SGL_GETPROCADDRESS wglGetProcAddress
#else
	#include <SDL.h>
	#define SGL_GETPROCADDRESS SDL_GL_GetProcAddress
#endif

/**
 declare function pointers for GLSL extension
 **/

extern PFNGLVERTEXATTRIB1FARBPROC pglVertexAttrib1fARB;
extern PFNGLVERTEXATTRIB1SARBPROC pglVertexAttrib1sARB;
extern PFNGLVERTEXATTRIB1DARBPROC pglVertexAttrib1dARB;
extern PFNGLVERTEXATTRIB2FARBPROC pglVertexAttrib2fARB;
extern PFNGLVERTEXATTRIB2SARBPROC pglVertexAttrib2sARB;
extern PFNGLVERTEXATTRIB2DARBPROC pglVertexAttrib2dARB;
extern PFNGLVERTEXATTRIB3FARBPROC pglVertexAttrib3fARB;
extern PFNGLVERTEXATTRIB3SARBPROC pglVertexAttrib3sARB;
extern PFNGLVERTEXATTRIB3FARBPROC pglVertexAttrib3dARB;
extern PFNGLVERTEXATTRIB4FARBPROC pglVertexAttrib4fARB;
extern PFNGLVERTEXATTRIB4SARBPROC pglVertexAttrib4sARB;
extern PFNGLVERTEXATTRIB4DARBPROC pglVertexAttrib4dARB;
extern PFNGLVERTEXATTRIB4NUBARBPROC pglVertexAttrib4NubARB;

extern PFNGLVERTEXATTRIB1FVARBPROC pglVertexAttrib1fvARB;
extern PFNGLVERTEXATTRIB1SVARBPROC pglVertexAttrib1svARB;
extern PFNGLVERTEXATTRIB1DVARBPROC pglVertexAttrib1dvARB;
extern PFNGLVERTEXATTRIB2FVARBPROC pglVertexAttrib2fvARB;
extern PFNGLVERTEXATTRIB2SVARBPROC pglVertexAttrib2svARB;
extern PFNGLVERTEXATTRIB2DVARBPROC pglVertexAttrib2dvARB;
extern PFNGLVERTEXATTRIB3FVARBPROC pglVertexAttrib3fvARB;
extern PFNGLVERTEXATTRIB3SVARBPROC pglVertexAttrib3svARB;
extern PFNGLVERTEXATTRIB3DVARBPROC pglVertexAttrib3dvARB;
extern PFNGLVERTEXATTRIB4FVARBPROC pglVertexAttrib4fvARB;
extern PFNGLVERTEXATTRIB4SVARBPROC pglVertexAttrib4svARB;
extern PFNGLVERTEXATTRIB4DVARBPROC pglVertexAttrib4dvARB;
extern PFNGLVERTEXATTRIB4IVARBPROC pglVertexAttrib4ivARB;
extern PFNGLVERTEXATTRIB4BVARBPROC pglVertexAttrib4bvARB;
extern PFNGLVERTEXATTRIB4UBVARBPROC pglVertexAttrib4ubvARB;
extern PFNGLVERTEXATTRIB4USVARBPROC pglVertexAttrib4usvARB;
extern PFNGLVERTEXATTRIB4UIVARBPROC pglVertexAttrib4uivARB;

extern PFNGLVERTEXATTRIB4NBVARBPROC pglVertexAttrib4NbvARB;
extern PFNGLVERTEXATTRIB4NSVARBPROC pglVertexAttrib4NsvARB;
extern PFNGLVERTEXATTRIB4NIVARBPROC pglVertexAttrib4NivARB;
extern PFNGLVERTEXATTRIB4NUBVARBPROC pglVertexAttrib4NubvARB;
extern PFNGLVERTEXATTRIB4NUSVARBPROC pglVertexAttrib4NusvARB;
extern PFNGLVERTEXATTRIB4NUIVARBPROC pglVertexAttrib4NuivARB;


extern PFNGLDELETEOBJECTARBPROC pglDeleteObjectARB;
extern PFNGLGETHANDLEARBPROC pglGetHandleARB;
extern PFNGLDETACHOBJECTARBPROC pglDetachObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC pglCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC pglShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC pglCompileShaderARB;
extern PFNGLCREATEPROGRAMOBJECTARBPROC pglCreateProgramObjectARB;
extern PFNGLATTACHOBJECTARBPROC pglAttachObjectARB;
extern PFNGLLINKPROGRAMARBPROC pglLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC pglUseProgramObjectARB;
extern PFNGLVALIDATEPROGRAMARBPROC pglValidateProgramARB;

extern PFNGLUNIFORM1FARBPROC pglUniform1fARB;
extern PFNGLUNIFORM2FARBPROC pglUniform2fARB;
extern PFNGLUNIFORM3FARBPROC pglUniform3fARB;
extern PFNGLUNIFORM4FARBPROC pglUniform4fARB;
extern PFNGLUNIFORM1IARBPROC pglUniform1iARB;
extern PFNGLUNIFORM2IARBPROC pglUniform2iARB;
extern PFNGLUNIFORM3IARBPROC pglUniform3iARB;
extern PFNGLUNIFORM4IARBPROC pglUniform4iARB;
extern PFNGLUNIFORM1FVARBPROC pglUniform1fvARB;
extern PFNGLUNIFORM2FVARBPROC pglUniform2fvARB;
extern PFNGLUNIFORM3FVARBPROC pglUniform3fvARB;
extern PFNGLUNIFORM4FVARBPROC pglUniform4fvARB;
extern PFNGLUNIFORM1IVARBPROC pglUniform1ivARB;
extern PFNGLUNIFORM2IVARBPROC pglUniform2ivARB;
extern PFNGLUNIFORM3IVARBPROC pglUniform3ivARB;
extern PFNGLUNIFORM4IVARBPROC pglUniform4ivARB;

extern PFNGLUNIFORMMATRIX2FVARBPROC pglUniformMatrix2fvARB;
extern PFNGLUNIFORMMATRIX3FVARBPROC pglUniformMatrix3fvARB;
extern PFNGLUNIFORMMATRIX4FVARBPROC pglUniformMatrix4fvARB;

extern PFNGLGETOBJECTPARAMETERFVARBPROC pglGetObjectParameterfvARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC pglGetObjectParameterivARB;
extern PFNGLGETINFOLOGARBPROC pglGetInfoLogARB;
extern PFNGLGETATTACHEDOBJECTSARBPROC pglGetAttachedObjectsARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC pglGetUniformLocationARB;
extern PFNGLGETACTIVEUNIFORMARBPROC pglGetActiveUniformARB;
extern PFNGLGETUNIFORMFVARBPROC pglGetUniformfvARB;
extern PFNGLGETUNIFORMIVARBPROC pglGetUniformivARB;
extern PFNGLGETSHADERSOURCEARBPROC pglGetShaderSourceARB;

/** pglobal function setting up the GLSL extension **/
bool glslSetupExtension();

#endif
